/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/gcn/gcn.md'.  */

#ifndef GCC_TM_PREDS_H
#define GCC_TM_PREDS_H

#ifdef HAVE_MACHINE_MODES
extern bool general_operand (rtx, machine_mode);
extern bool address_operand (rtx, machine_mode);
extern bool register_operand (rtx, machine_mode);
extern bool pmode_register_operand (rtx, machine_mode);
extern bool scratch_operand (rtx, machine_mode);
extern bool immediate_operand (rtx, machine_mode);
extern bool const_int_operand (rtx, machine_mode);
extern bool const_double_operand (rtx, machine_mode);
extern bool nonimmediate_operand (rtx, machine_mode);
extern bool nonmemory_operand (rtx, machine_mode);
extern bool push_operand (rtx, machine_mode);
extern bool pop_operand (rtx, machine_mode);
extern bool memory_operand (rtx, machine_mode);
extern bool indirect_operand (rtx, machine_mode);
extern bool ordered_comparison_operator (rtx, machine_mode);
extern bool comparison_operator (rtx, machine_mode);
extern bool gcn_conditional_register_operand (rtx, machine_mode);
extern bool gcn_ssrc_register_operand (rtx, machine_mode);
extern bool gcn_sdst_register_operand (rtx, machine_mode);
extern bool gcn_vgpr_register_operand (rtx, machine_mode);
extern bool gcn_inline_immediate_operand (rtx, machine_mode);
extern bool gcn_vop3_operand (rtx, machine_mode);
extern bool gcn_vec0_operand (rtx, machine_mode);
extern bool gcn_vec1_operand (rtx, machine_mode);
extern bool gcn_vec1d_operand (rtx, machine_mode);
extern bool gcn_const1d_operand (rtx, machine_mode);
extern bool gcn_32bit_immediate_operand (rtx, machine_mode);
extern bool gcn_exec_operand (rtx, machine_mode);
extern bool gcn_exec_reg_operand (rtx, machine_mode);
extern bool gcn_load_operand (rtx, machine_mode);
extern bool gcn_alu_operand (rtx, machine_mode);
extern bool gcn_ds_memory_operand (rtx, machine_mode);
extern bool gcn_valu_dst_operand (rtx, machine_mode);
extern bool gcn_valu_src0_operand (rtx, machine_mode);
extern bool gcn_valu_src1_operand (rtx, machine_mode);
extern bool gcn_valu_src1com_operand (rtx, machine_mode);
extern bool gcn_conditional_operator (rtx, machine_mode);
extern bool gcn_compare_64bit_operator (rtx, machine_mode);
extern bool gcn_compare_operator (rtx, machine_mode);
extern bool gcn_fp_compare_operator (rtx, machine_mode);
extern bool unary_operator (rtx, machine_mode);
extern bool binary_operator (rtx, machine_mode);
extern bool gcn_unspec_operand (rtx, machine_mode);
extern bool general_or_unspec_operand (rtx, machine_mode);
extern bool gcn_register_or_unspec_operand (rtx, machine_mode);
extern bool gcn_alu_or_unspec_operand (rtx, machine_mode);
extern bool gcn_register_ds_or_unspec_operand (rtx, machine_mode);
extern bool ascending_zero_int_parallel (rtx, machine_mode);
#endif /* HAVE_MACHINE_MODES */

#define CONSTRAINT_NUM_DEFINED_P 1
enum constraint_num
{
  CONSTRAINT__UNKNOWN = 0,
  CONSTRAINT_r,
  CONSTRAINT_v,
  CONSTRAINT_Sg,
  CONSTRAINT_SD,
  CONSTRAINT_SS,
  CONSTRAINT_Sm,
  CONSTRAINT_Sv,
  CONSTRAINT_ca,
  CONSTRAINT_cs,
  CONSTRAINT_cV,
  CONSTRAINT_e,
  CONSTRAINT_I,
  CONSTRAINT_J,
  CONSTRAINT_Kf,
  CONSTRAINT_L,
  CONSTRAINT_m,
  CONSTRAINT_o,
  CONSTRAINT_RB,
  CONSTRAINT_RF,
  CONSTRAINT_RS,
  CONSTRAINT_RL,
  CONSTRAINT_RG,
  CONSTRAINT_RD,
  CONSTRAINT_RM,
  CONSTRAINT_p,
  CONSTRAINT_A,
  CONSTRAINT_B,
  CONSTRAINT_C,
  CONSTRAINT_DA,
  CONSTRAINT_Db,
  CONSTRAINT_DB,
  CONSTRAINT_U,
  CONSTRAINT_Y,
  CONSTRAINT_V,
  CONSTRAINT__l,
  CONSTRAINT__g,
  CONSTRAINT_i,
  CONSTRAINT_s,
  CONSTRAINT_n,
  CONSTRAINT_E,
  CONSTRAINT_F,
  CONSTRAINT_X,
  CONSTRAINT__LIMIT
};

extern enum constraint_num lookup_constraint_1 (const char *);
extern const unsigned char lookup_constraint_array[];

/* Return the constraint at the beginning of P, or CONSTRAINT__UNKNOWN if it
   isn't recognized.  */

static inline enum constraint_num
lookup_constraint (const char *p)
{
  unsigned int index = lookup_constraint_array[(unsigned char) *p];
  return (index == UCHAR_MAX
          ? lookup_constraint_1 (p)
          : (enum constraint_num) index);
}

extern bool (*constraint_satisfied_p_array[]) (rtx);

/* Return true if X satisfies constraint C.  */

static inline bool
constraint_satisfied_p (rtx x, enum constraint_num c)
{
  int i = (int) c - (int) CONSTRAINT_I;
  return i >= 0 && constraint_satisfied_p_array[i] (x);
}

static inline bool
insn_extra_register_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_r && c <= CONSTRAINT_e;
}

static inline bool
insn_extra_memory_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_m && c <= CONSTRAINT_o;
}

static inline bool
insn_extra_special_memory_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_RB && c <= CONSTRAINT_RM;
}

static inline bool
insn_extra_relaxed_memory_constraint (enum constraint_num)
{
  return false;
}

static inline bool
insn_extra_address_constraint (enum constraint_num c)
{
  return c >= CONSTRAINT_p && c <= CONSTRAINT_p;
}

static inline void
insn_extra_constraint_allows_reg_mem (enum constraint_num c,
				      bool *allows_reg, bool *allows_mem)
{
  if (c >= CONSTRAINT_A && c <= CONSTRAINT_Y)
    return;
  if (c >= CONSTRAINT_V && c <= CONSTRAINT__g)
    {
      *allows_mem = true;
      return;
    }
  (void) c;
  *allows_reg = true;
  *allows_mem = true;
}

static inline size_t
insn_constraint_len (char fc, const char *str ATTRIBUTE_UNUSED)
{
  switch (fc)
    {
    case 'D': return 2;
    case 'K': return 2;
    case 'R': return 2;
    case 'S': return 2;
    case 'c': return 2;
    default: break;
    }
  return 1;
}

#define CONSTRAINT_LEN(c_,s_) insn_constraint_len (c_,s_)

extern enum reg_class reg_class_for_constraint_1 (enum constraint_num);

static inline enum reg_class
reg_class_for_constraint (enum constraint_num c)
{
  if (insn_extra_register_constraint (c))
    return reg_class_for_constraint_1 (c);
  return NO_REGS;
}

extern bool insn_const_int_ok_for_constraint (HOST_WIDE_INT, enum constraint_num);
#define CONST_OK_FOR_CONSTRAINT_P(v_,c_,s_) \
    insn_const_int_ok_for_constraint (v_, lookup_constraint (s_))

enum constraint_type
{
  CT_REGISTER,
  CT_CONST_INT,
  CT_MEMORY,
  CT_SPECIAL_MEMORY,
  CT_RELAXED_MEMORY,
  CT_ADDRESS,
  CT_FIXED_FORM
};

static inline enum constraint_type
get_constraint_type (enum constraint_num c)
{
  if (c >= CONSTRAINT_RB)
    {
      if (c >= CONSTRAINT_A)
        return CT_FIXED_FORM;
      if (c >= CONSTRAINT_p)
        return CT_ADDRESS;
      return CT_SPECIAL_MEMORY;
    }
  if (c >= CONSTRAINT_m)
    return CT_MEMORY;
  if (c >= CONSTRAINT_I)
    return CT_CONST_INT;
  return CT_REGISTER;
}
#endif /* tm-preds.h */
